#pragma once
#include "DTV_Base.h"
#include "usbio.h"
#include <list>

#define DTV_EzUSBFX2_ASYNC_XFER_REQ_NUM		32
#define DTV_EzUSBFX2_ASYNC_XFER_SIZE		0x8000

class CDTV_EzUSBFX2_Direct_HvMikitty : public CDTV_Base
{
public:
	CDTV_EzUSBFX2_Direct_HvMikitty();
	virtual ~CDTV_EzUSBFX2_Direct_HvMikitty(void);

	BOOL Initialize(char *szInitString=NULL,HWND hWnd=NULL,GUID *pGuid=NULL);
	void Release();
	BOOL IsInitialized();

	DWORD GetExtFunction();
	DWORD GetDeviceCount();
	BOOL GetDeviceName(int iDevNo,char *lpszDevName,int iBufLen);
	DWORD GetUsbEndpointCount(int iDevNo);
	BOOL GetUsbEndpointInfo(int iDevNo,int iUsbEpNo,struct DTV_UsbEndpointInfo *pUsbEpInfo);
	BOOL IsEndpointEffective(int iDevNo,int iUsbEpAddr);

	BOOL Connect(int iDevNo,int iInEpAddr,int iOutEpAddr);
	void DisConnect();
	BOOL IsConnect();

	DWORD XferRequestProc(struct DTV_ThreadParam *lpParameter);
	DWORD XferResponceProc(struct DTV_ThreadParam *lpParameter);

public:
	// pNXƎ
	void SetHvMikittyInit(BOOL bFlg)
	{
		m_bHvMikittyInit=bFlg;
	}

protected:	
	// Jnp[^
	struct DTV_EzUSBFX2_ReqParam
	{
		BYTE byEP_In;
		BYTE byEP_Out;
	};
	// 񓯊]L[
	struct DTV_EzUSBFX2_Request
	{
		OVERLAPPED		Overlap;
		BYTE			byEndPoint;
		PUCHAR			pContext;
		CyUSB_IoHeader	Request;

		BYTE buf[DTV_EzUSBFX2_ASYNC_XFER_SIZE];
		LONG buf_len;
		DWORD recv_size;
	};

	HANDLE m_hDevice;
	BOOL m_bOpen;
	std::list<struct DTV_EzUSBFX2_Request*>	m_ReqWait;	// NGXg\
	std::list<struct DTV_EzUSBFX2_Request*>	m_ReqBusy;	// NGXg
	CRITICAL_SECTION m_stCS;
	BOOL m_bHvMikittyInit;

	BOOL MakeXferQueue();
	void FreeXferQueue();

	BOOL GetDriverPath(GUID *pGuid, LPSTR lpszPath);
	int XferData(HANDLE hDevice,DWORD dwIoCode, BYTE *pSendData, DWORD dwSendSize, BYTE *pRecvBuf, DWORD dwRecvBufLen,BOOL bOverlap=true);
	BOOL BeginDataXfer(HANDLE hDevice, DWORD dwIoCode, BYTE *pSendData, DWORD dwSendSize, BYTE *pRecvBuf,DWORD dwRecvBufLen,DWORD *pRecvSize,OVERLAPPED *pOvelap);
};
